/* action.c -- exception handler and default action for wwbump MicroACE */

#include <wwbump.h>
#include <stdlib.h>
#include <wwbcc.h>

/* 
  Our exception handler.  It needs to do three things :  
   - get the exception code (MANDETORY)
   - increment the count
   - forward the packet back down to the microengine
*/
int exception(void *ctx, ix_ring r, ix_buffer b)
{
    /* ctx is the ACE */
    struct wwbump *wwb = (struct wwbump *) ctx; 
    ix_error e;
    unsigned char c;
    (void) r;	/* prevents compiler warnings */


    /* Now get the exception code : THIS MUST MUST MUST BE DONE */
    e = RmGetExceptionCode(wwb->tag, &c);
    if ( e ) {
        fprintf(stderr, "%s:  Error getting exception code", 
                wwb->name);
        ix_error_dump(stderr, e);
        ix_buffer_del(b);
        return e;
    }


    /* All this code for one line of action!  Sheesh! */
    Webcnt++;


    /* Send the packet back down to our microblock group */
    /* our TAG is used to figure out an appropriate microengine */
    e = RmSendPacket(wwb->tag, b);
    if ( e ) {
        ix_error_dump(stderr, e);
        ix_buffer_del(b);
        return e;
    }


    return 0;
}





/* This function must be included.  It recieves frames from other    */
/* StrongARM components of other ACEs.  Since our only count path is */
/* from the microengines we delete all other packets sent to us      */
int ix_action_default(ix_ace * a, ix_buffer b)
{
    (void) a;		/* prevents warnings */
    ix_buffer_del(b);	/* Delete all frames */
    return RULE_DONE;	/* MUST do this */
}
